﻿using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace WpfApp6
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            DataContext = new MainViewModel();
            listBox.AddHandler(RadListBox.MouseLeftButtonDownEvent, new MouseButtonEventHandler(RadListBox_MouseLeftButtonDown), true);
        } 

        private void RadListBox_MouseLeftButtonDown(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var clickedElement = (FrameworkElement)e.OriginalSource;
            var parentExpander = clickedElement.ParentOfType<RadExpander>();
            if (parentExpander != null)
            {
                listBox.SelectedItem = parentExpander.DataContext;
            }
        }
    }

    public class MainViewModel : ViewModelBase
    {
        private ItemInfo selectedItem;

        public ItemInfo SelectedItem
        {
            get { return selectedItem; }
            set { selectedItem = value; OnPropertyChanged("SelectedItem"); }
        }

        public ObservableCollection<ItemInfo> Items { get; set; }

        public MainViewModel()
        {
            this.Items = new ObservableCollection<ItemInfo>();
            for (int i = 0; i < 10; i++)
            {
                var itemInfo = new ItemInfo() { Name = "Item " + i, GridData = new ObservableCollection<RowInfo>() };
                for (int k = 0; k < 3; k++)
                {
                    itemInfo.GridData.Add(new RowInfo() { ParameterName = "Row " + i, ParameterValue = k });
                }
                Items.Add(itemInfo);
            }
        }
    }

    public class ItemInfo
    {
        public ObservableCollection<RowInfo> GridData { get; set; }
        public string Name { get; set; }
    }

    public class RowInfo
    {
        public string ParameterName { get; set; }
        public double ParameterValue { get; set; }
    }
}
